; Test program for Ion that uses each of the routines in sprite.asm

#ifdef TI83P
#include "ion.inc"
.org    progstart-2
.db     $BB,$6D
#endif

#ifdef TI83
#include "ion.inc"
.org    progstart
#endif

#ifdef TI86
#define equ .equ
#include "ti86.inc"
.org    _asm_exec_ram
#define SPRITE_86
#define bcall(xxxx) call xxxx
#endif

#ifndef TI86
        ret
        jr      nc,start
.db     "Sprite Routine Tester",0
#else
        nop
        jp      start
        .dw     0
        .dw     title
title:
.db     "Sprite Routine Tester",0
#endif

start:
        bcall(_grbufclr)

; Use putAlignedSprite
        ld      a,5                             ; X coord (aligned to 8x8 block)
        ld      l,6                             ; Y coord (aligned to 8x8 block)
        ld      de,sprFace                      ; DE => Sprite data
        call    putAlignedSprite

; Use putMaskedAlignedSprite
        ld      a,3                             ; X coord (aligned to 8x8 block)
        ld      l,1                             ; Y coord (aligned to 8x8 block)
        ld      de,sprCheckered                 ; DE => Sprite data for checkered square
        call    putAlignedSprite                ; Draw the square
        ld      a,3
        ld      l,1
        ld      de,sprMaskedFace                ; DE => Sprite data for face (with mask data)
        call    putMaskedAlignedSprite          ; Draw over the top of the checkered square to see the "masking" effect

; Use putSprite
        ld      a,53                            ; X coord
        ld      l,21                            ; Y coord
        ld      de,sprCheckered                 ; DE => Sprite data
        call    putSprite                       ; Draw sprite

; Use putClippedSprite
        ld      b,-3                            ; X coord (off left of screen)
        ld      c,59                            ; Y coord (will hang off bottom of screen)
        ld      hl,sprFace
        call    putClippedSprite                ; Draw clipped sprite
        ld      b,-3
        ld      c,59
        ld      hl,sprCheckered
        call    putClippedSprite                ; Draw checkered box over the face (no masking)

; Use putClippedMaskedSprite
#ifdef TI86
        ld      b,125
#else
        ld      b,93
#endif
        ld      c,-2
        ld      hl,sprMaskedFace
        call    putClippedMaskedSprite          ; Draw masked face with clipping off top right of screen

; Use putSprite with variable height sprite
        ld      a,4
        ld      (putSpriteHeight),a             ; Set sprite height to 4
        ld      a,24                            ; X coord
        ld      l,4                             ; Y coord
        ld      de,sprShip                      ; DE => Sprite data
        call    putSprite

; Copy gbuf to video, wait for a key then quit
        call    ionFastCopy
        bcall(_getkey)
        ret

#ifdef TI86
_grbufclr:
        ld      hl,gbuf
        ld      de,gbuf+1
        ld      bc,1023
        ld      (hl),0
        ldir
        ret

ionFastCopy:
        ld      hl,gbuf
        ld      de,$FC00
        ld      bc,1024
        ldir
        ret
#endif

#define PUT_ALIGNED_SPRITE
#define PUT_MASKED_ALIGNED_SPRITE
#define PUT_SPRITE
#define PUT_CLIPPED_SPRITE
#define PUT_CLIPPED_MASKED_SPRITE
#include "sprite.asm"

sprFace:
.db %00111100
.db %01000010
.db %10100101
.db %10000001
.db %10100101
.db %10011001
.db %01000010
.db %00111100

sprCheckered:
.db %10101010
.db %01010101
.db %10101010
.db %01010101
.db %10101010
.db %01010101
.db %10101010
.db %01010101

sprShip:
.db %00010000
.db %00111000
.db %01111100
.db %01000100

sprMaskedFace:
.db %00111100
.db %01000010
.db %10100101
.db %10000001
.db %10100101
.db %10011001
.db %01000010
.db %00111100
.db %00111100
.db %01111110
.db %11111111
.db %11111111
.db %11111111
.db %11111111
.db %01111110
.db %00111100

.end
